

struct commandTable {
  char comm[50];
  int len;
};


typedef struct rcvBLEAdvertising {
  char macId[12];          //アドレス(Macアドレス)
  char adAdrType[1];       //adress type  1=ランダム,0=固定
  char rssi[3];            //rssi値
  char comm[80];
  char dummy[2];
  char len;

}rcvBLEadv;

typedef union  rcvBLEAdvType{
    char  cmd[100];
    rcvBLEadv   rcvadv;
       
}uni_rcvUNIBLE;

#define COM_ECHO_ON           1
#define COM_REBOOT            2
#define COM_OVSERV_ROL_ON     3
#define COM_OVSERV_ROL_OFF    4
#define COM_SCAN_BROADCAST_A  5  // 500ms 間隔30s
#define COM_SCAN_BROADCAST_B  6  //1000ms 間隔30s
#define COM_SCAN_BROADCAST_C  7  //時間指定なし

#define COM_SET_FANC_A        8  //Central Server Only
#define COM_SET_FANC_B        9  //Central 

#define COM_STOP_BROAD_RCV    10  //X ブロードキャスト受信停止 
#define COM_FIRM_VER_CHK      11  //V ファームウェアバージョンチェック

struct commandTable echo         = { "+",1};
struct commandTable reboot       = { "R,1",3};
struct commandTable observRolOn  = { "J,1",3};
struct commandTable observRolOff = { "J,0",3};
struct commandTable scanBroad_A  = { "F,03E8,01F4",11};  // 1000ms,500ms
struct commandTable scanBroad_B  = { "F,0100,0100",11};  // 5000ms,550ms
struct commandTable scanBroad_C  = { "F",1};  //1000ms,30s

struct commandTable function_A   = { "SR,80002000",11};  //Function Central, Server Only
struct commandTable function_B   = { "SR,80000000",11};  //Function Central

struct commandTable scanBroadStop ={ "X",1};  //Bcast Rcv Stop
struct commandTable firmVersion  = { "V",1};   //ファームウェアバージョン


struct commandTable list        = { "LS",2};
struct commandTable advertise   = { "A",1};
struct commandTable rssi        = { "M",1};
struct commandTable stopAdv     = { "Y",1};
struct commandTable deviceinfo  = { "D",1};
struct commandTable serviceRole = { "SS,40000001",11}; //Battery + private
struct commandTable Function    = { "SR,00000000",11}; //機能機能変更機能変更なし
struct commandTable battService = { "SUW,2A19,32",11};
struct commandTable devName     = { "S-,R-King",9};
struct commandTable priService  = { "PS,cb9cf8fba8104baf9ad8da094ffd166c",35};
struct commandTable priCharact  = { "PC,B6F0FB56216441CFBC5867AE76320782,02,04",41}; //readOnly : 4byte Length
struct commandTable priClear    = { "PZ",2};
struct commandTable reset       = { "SF,2",4};
struct commandTable baudRate    = { "SB,1",4}; //baud rate 9600

char recvCharPC;      //1バイトシリアル受信データ
char recvCharRN4020;  

char sendComId;


void initRN4020();

int  rcvPcCommand();
void rn4020_WriteCommand(int controlNumber );
void rn4020_RCVCommand();

#include "mbed.h"
#include "main01.h"
#include "modeCtr.h"

Serial pc2(USBTX, USBRX); // tx, rx
Serial rn4020_uart(P7_4,P7_5);
//RN4020 制御端子UART端子を指定


//----------------------------------------
//  受信用バッファ１
//----------------------------------------
  
  
//----------------------------------------
//  受信用バッファ2
//  アドバタイジングパケット受信用一時バッファ
//----------------------------------------

#define  MAX_OneMes     100           //1メッセージあたりの最大の長さ(仮サイズ）
#define  MAX_WordSize   200           //

char rcvDataBuff[MAX_WordSize][MAX_OneMes];
char bufLineRcvID;
char bufLineWordId; 

bool FgAdvRcvOn;
    

//----------------------------------------------
// iBeacon ID登録  
//----------------------------------------------

//char testBeaconA[]="00CDFF00360E";

#define BeconNum     3      //発信機側（ビーコン受信チェックできる最大数）
#define Beacon01     0
#define Beacon02     1
#define Beacon03     2

    
//----------------------------------------
//  Unity 用送信バッファ
//----------------------------------------
#define MAX_RCV_BEACON  3

#define RCV_BEACON01    0   //暫定の定義
#define RCV_BEACON02    1   //暫定の定義(最終は可変にしたい）
#define RCV_BEACON03    2   //暫定の定義

#define BEACON_ID_SIZE     13   //   
#define BEACON_RSSI_SIZE    4   //   

bool FgUnitySendOn; //PC向けの送信を制限する

//固定のビーコン（ID1)で受信用バッファにする
//発信機ビーコン３種類用のバッファ
char  BEACON_ID[BeconNum][BEACON_ID_SIZE];
char  BEACON_RSSI[BeconNum][BEACON_RSSI_SIZE];
char  BEACON_RCV_ENAVLE[BeconNum][BeconNum];



#define RECEIVER01_ID  "000001"
#define RECEIVER02_ID  "000002"
#define RECEIVER03_ID  "000003"



//#define BECON_MACID01   "00CDFF00360E"     //Beacon 01

#define BECON_MACID01   "D436399737AB"     //Beacon 01
#define BECON_MACID02   "606405D1B234"     //Beacon 02
#define BECON_MACID03   "D43639973071"      //Beacon 03

void get_BeaconMacID(int beconId,char* stID);
void get_ReceiverID(int receiverId,char* stID);
    

void loopAction() {
    int rcvCom;
    rcvCom = rcvPcCommand();// コマンド受信
    
    //受信コマンドに対してモード制御
    
    //sendComId グローバル 受信指示とうまく調整する。
    //rcvCom
    seqCtrl();      //モード制御処理

    rn4020_WriteCommand(sendComId);
    
    sendComId=0;//暫定処理（Ｃｔｒの後に必ず送信する仕組みの間はこの処理でもＯＫ）
    
    
    rn4020_RCVCommand();    
  
}


void initRN4020(){

//TEST
    bufLineRcvID =0;
    bufLineWordId=0; 
    FgAdvRcvOn=false;

    //unity 送信用データ
    FgUnitySendOn=true;  //送信停止
    
//TEST

  sendComId = 0;

  pc2.printf("------PEACH RESTART------\r\n");
  rn4020_uart.baud(115200);

  pc2.printf("------Please Wait ------\r\n");
  wait_ms(2000);  //ボーレート設定　RN4020 デフォルト

  pc2.printf("------Echo ON     ------\r\n");  
//  rn4020_uart.printf(echo.comm);
//  wait_ms(500);  //エコーON
   

}



void rn4020_WriteCommand(int controlNumber )
{
     
      switch(controlNumber){
          case COM_ECHO_ON:
            rn4020_uart.printf(echo.comm);
            rn4020_uart.printf("\n");
            break;

          case COM_REBOOT:
            rn4020_uart.printf(reboot.comm);
            rn4020_uart.printf("\n");
            break;

          case COM_OVSERV_ROL_ON:
            rn4020_uart.printf(observRolOn.comm);
            rn4020_uart.printf("\n");
            break;

          case COM_OVSERV_ROL_OFF:
            rn4020_uart.printf(observRolOff.comm);
            rn4020_uart.printf("\n");
            break;

          case COM_SCAN_BROADCAST_A:
            rn4020_uart.printf(scanBroad_A.comm);
            rn4020_uart.printf("\n");
            break;

          case COM_SCAN_BROADCAST_B:
            rn4020_uart.printf(scanBroad_B.comm);
            rn4020_uart.printf("\n");
            break;

          case COM_SCAN_BROADCAST_C:
            rn4020_uart.printf(scanBroad_C.comm);
            rn4020_uart.printf("\n");
            break;

          case COM_SET_FANC_A:
            rn4020_uart.printf(function_A.comm);
            rn4020_uart.printf("\n");
            break;

          case COM_SET_FANC_B:
            rn4020_uart.printf(function_B.comm);
            rn4020_uart.printf("\n");
            break;


          case COM_STOP_BROAD_RCV:
            rn4020_uart.printf(scanBroadStop.comm);
            rn4020_uart.printf("\n");
            break;

          case COM_FIRM_VER_CHK:
            rn4020_uart.printf(firmVersion.comm);
            rn4020_uart.printf("\n");
            break;

          default :
            break;
      }
  
}


//    uni_rcvUNIBLE   rcvAdvCommand;





void rn4020_RCVCommand()
{
    
    char rcvCommand;
    

     //受信したコマンドの書き込み
     while(rn4020_uart.readable()){
       
       rcvCommand = rn4020_uart.getc();
              

//       rcvAdvCommand.cmd[counter]= rcvCommand;     
//       counter++;

        //送信制限をかける（Unityよう）
        if(FgUnitySendOn==true){
           pc2.putc(rcvCommand);
        }              

       //TEST-------------------------------------
       
       if(FgAdvRcvOn==true){
       
           rcvDataBuff[bufLineRcvID][bufLineWordId]=
           rcvCommand;
                
            bufLineWordId++;
            
            if(rcvCommand =='\n'){
                bufLineRcvID++;
                bufLineWordId=0;
                
                if(bufLineRcvID>=MAX_WordSize){
                    bufLineRcvID=0;
                }
            }
        }              
     }
              
}


/*
  PC からのコマンド受信処理  
*/

int rcvPcCommand(){
    int command =0;
    /* 1ループ１回の処理にする　    */
    if(pc2.readable()){
        recvCharPC = pc2.getc();
        switch(recvCharPC){
            case '1':
                command =COM_ECHO_ON;
                break;
            case '2':
                command =COM_REBOOT;
                break;
                
            case '3':
                command =COM_OVSERV_ROL_ON;
                break;
                
            case '4':
                command =COM_OVSERV_ROL_OFF;
                break;
                
            case '5':
                command =COM_SCAN_BROADCAST_A;
                break;
                
            case '6':
                command =COM_SCAN_BROADCAST_B;
                break;

            case '7':
                command =COM_SCAN_BROADCAST_C;
                break;
                                
            case '8':
                command =COM_SET_FANC_A;
                break;
                
            case '9':
                command =COM_SET_FANC_B;
                break;

            case 'x':
                command =COM_STOP_BROAD_RCV;
                break;

            case 'v':
                command =COM_FIRM_VER_CHK;
                break;


            default :
                break;
                
        }
    }    
  return command;
}


void get_BeaconMacID(int beconId,char* stID){
    
    switch(beconId){
        case Beacon01:
            strcpy(stID,BECON_MACID01);

              break;
        case Beacon02:
            strcpy(stID,BECON_MACID02);
            break;
        case Beacon03:
            strcpy(stID,BECON_MACID03);
            break;
        default:
            break;
    }    
}

void get_ReceiverID(int receiverId,char* stID){
    
    switch(receiverId){
        case RCV_BEACON01:
            strcpy(stID,RECEIVER01_ID);
            break;
        case RCV_BEACON02:
            strcpy(stID,RECEIVER02_ID);
            break;
        case RCV_BEACON03:
            strcpy(stID,RECEIVER03_ID);
            break;
        default:
            break;
    }    
}
