
#include "mbed.h"

//TCP/IP 制御に必要な定義（MBED5.x 標準ライブラリ）
#include "EthernetInterface.h"
#include "UDPSocket.h"

//共通定義
#include "ipdef.h"          //初期値定義
#include "rn4020CtrMain.h"  //ビーコンID情報等

//Class 定義
#include "UDPctr.h"      

#include "modeCtr.h"


// Network interface
//-------------------------------------
// MAC Addres 設定
//-------------------------------------
void mbed_mac_address(char *mac){
    
    int defNo;
    
    defNo = (int)DEF_RECEIVER_ID_SELECT;
    
    char macID;
    
    switch (defNo){
        case 1:
            macID=0x01;
            break;
        case 2:
            macID=0x02;
            break;
        
        case 3:
            macID=0x03;
            break;
        
        default :            
            macID=0x00;
            break;
       
    }
    
    mac[0]=0x00;   
    mac[1]=0x02;   
    mac[2]=0xF7;   
    mac[3]=0xF0;   
    mac[4]=0x00;   
    mac[5]=macID; 

}
//-------------------------------------

UDPctr::UDPctr()  {
//コンストラクタ？




}

//メソッド 初期化用
void UDPctr::EtherOpen() {

    printf("\r\n");
    printf("*************************************\r\n");
    printf("Ethernet socket \r\n");
    printf("*************************************\r\n");
    //-------------------------------
    // IPアドレス設定
    //-------------------------------

    //固定IP設定 DHCP 使用時は１行削除
    //スレーブレシーバの切り替え処理はまだはいっていない（定義を変えてコンパイルす必要あり）
//    int result= net.set_network (DEF_RECEIVER_03_IP, DEF_RECEIVER_02_NETMASK, DEF_RECEIVER_02_GATEWAY);    
    int result = net.set_dhcp(true);     //DHCPからIP取得

    int result2 = net.connect(); //固定の時もコネクト必要みたい

    if((result ==0)&&(result2==0)){
        printf("connect result=OK \r\n");

        // Show the network address
        const char *ip = net.get_ip_address();
        const char *mac = net.get_mac_address();

        printf("IP address is: %s\r\n", ip ? ip : "No IP");
        printf("MAC address is: %s\r\n", mac ? mac : "No MAC");
    
    }else{
        printf("connect result=NG,%d \r\n",result);
        
    }


}

void UDPctr::EtherClose() {
    //network close処理
    net.disconnect();
    printf("Ethernet Close\r\n");
    
}

void UDPctr::UDPSocketOpen() {

    //本当はOpne Close状態をチェックするべき…    
    int rs=udpsocket.open(&net);
    if(rs==0){
        printf("udp socket Open OK \r\n");
    }else{
        printf("udp socket NG      \r\n");
    }
    //ポート設定(一旦この中に入れる）分離するかは別途検討
    udpsocket.bind(UDP_Port_SLAVE_RCV);     //スレーブーレシーバ用設定ポート設定
    udpsocket.set_blocking(false);           //ブロッキングモード on
    udpsocket.set_timeout(3000);           //ブロッキングモード on
    

    //----------------------------------------
    rs=udpsocketCam.open(&net);
    if(rs==0){
        printf("udp socketCAM Open OK \r\n");
    }else{
        printf("udp socketCAM NG      \r\n");
    }
    //ポート設定(一旦この中に入れる）分離するかは別途検討
    udpsocketCam.bind(UDP_Port_SLAVE_RCVCAM);  //スレーブーレシーバ用設定ポート設定
    udpsocketCam.set_blocking(true);           //ブロッキングモード on


                                                                                         


}

void UDPctr::UDPSocketClose() {

    //本当はOpne Close状態をチェックするべき…

    udpsocket.close();
    printf("udp socket close\r\n");

    
}



//----------------------------------
void UDPctr::MainCtr() {


}


//-----------------------------------------------------------------
//マスター用コマンド送信関数(処理封印）
//-----------------------------------------------------------------
//１コマンド送信処理（いったん引数なし）
void UDPctr::MSTsendUDPcom(int sendSlvNo) {



}

//１メッセージ受信処理（いったん引数なし）（マスターレシーバあて）
void UDPctr::MSTrcvUDPcom() {


    
}


//-----------------------------------------------------------------
//スレーブ用コマンド送信関数
//-----------------------------------------------------------------

//-----------------------------------------------------------------
//Unity に送信送信Jpegデータを送信する処理
//送信が分かるようにレシーバIDを指定・・・はするが固定送信だけにする（いったん）
//-----------------------------------------------------------------
void UDPctr::SLVsendUDPcomData(char * sendBffer,long sendSize) {//3ビーコンコマンド送信専用（暫定）

    //SleveNo コンパイルで自動設定
    int DefRcvNo;    
    int slvNo; 

    DefRcvNo = (int)DEF_RECEIVER_ID_SELECT;
    
    switch(DefRcvNo){
        case 1:
            slvNo=RCV_BEACON01; //レシーバ01
            break;
        case 2:
            slvNo=RCV_BEACON02; //レシーバ02
            break;
        
        case 3:
            slvNo=RCV_BEACON03; //レシーバ03
            break;
        
        default :            
            slvNo=0xff;
            break;
        
    }
    
    

    //自分＝送信者のレシーバIDを指定する
    //コマンドの受け渡しの引数を考える必要あり文字列配列だろうなぁ～    
    //UDP socket open 前提 で本メソッドは使用すること

    bool    checkFg = true;    

    //エラーチェック
    //自分のレシーバIDをチェック
    //対応レシーバ数を増やす場合テーブル追加＋条件追加必要
    switch(slvNo){
        case RCV_BEACON02:
        case RCV_BEACON03:
        case RCV_BEACON01:
             break;            
        default:            //その他も誤り
            checkFg=false;  
            break;        
    }


    if(sendSize<0){
        checkFg=false;
    }
    //-------------------------------------
    // 送信データの作成（送信先はマスターレシーバ）
    //-------------------------------------
    if(checkFg==true){

        char sbufferUDP0[sendSize];                             
        memcpy(sbufferUDP0,sendBffer,sendSize); //もう必要ないけど・・・
        
        //送信先はUNTY,イメージ用ポートを指定  s_imagebuf1
//        int scountUDP = udpsocket.sendto(DEF_UNITY_IP, UDP_Port_MASTER_IMAGE, sendBffer  , sendSize);
        int scountUDP = udpsocket.sendto(DEF_UNITY_IP, UDP_Port_MASTER_IMAGE, sbufferUDP0  , sendSize); 
         
        //送信OKになっていても実際には外部への送信は完了していない
        //一定時間経過するまではソケットのクローズは行わないこと（早すぎると送信が完了しない）
        
        
        printf("\r\n");        
        printf("------------------------\r\n");        
        printf("Sent UDP Byte %d Data---> \r\n [%d]\r\n", scountUDP, sendBffer);
        printf("To IP %s Port %d_\r\n",DEF_UNITY_IP,UDP_Port_MASTER_IMAGE);
        printf("------------------------\r\n");        
        
    } 
}


//----------------------------------------------
void UDPctr::SLVsendUDPcom(char * rssiBf0,char * rssiBf1,char * rssiBf2) {//3ビーコンコマンド送信専用（暫定）


    bool    checkFg = true;    

    //SleveNo コンパイルで自動設定
    int DefRcvNo;    
    int slvNo; 

    DefRcvNo = (int)DEF_RECEIVER_ID_SELECT;
    
    switch(DefRcvNo){
        case 1:
            slvNo=RCV_BEACON01; //レシーバ01
            break;
        case 2:
            slvNo=RCV_BEACON02; //レシーバ02
            break;
        
        case 3:
            slvNo=RCV_BEACON03; //レシーバ03
            break;
        
        default :            
            slvNo=0xff;
            break;
        
    }
    



    //エラーチェック
    //自分のレシーバIDをチェック
    //対応レシーバ数を増やす場合テーブル追加＋条件追加必要
    switch(slvNo){
        case RCV_BEACON02:
        case RCV_BEACON03:            
        case RCV_BEACON01:  //方針変更したのでこれでOK
            break;
        default:            //その他のみ誤り
            checkFg=false;
            break;        
    }
    
    //-------------------------------------
    // 送信データの作成（送信先はマスターレシーバ）
    //-------------------------------------
    if(checkFg==true){
        
        char sbufferUDP0[50];                     //送信バッファ
        char sbufferUDP1[] = "BeconRecever/";       //送信文字列  /BeconRecever/   キーワード
        strcpy(sbufferUDP0,sbufferUDP1);             //           

        char sbuffer2[7];                            //          BeaconレシーバID
        get_ReceiverID(slvNo,sbuffer2);
               
        strcat(sbufferUDP0,sbuffer2);                //  /BeconRecever/606405D1B234   ってなるはず・・・
        


        //Beacon RSSIデータ        
        strcat(sbufferUDP0,"/");
        strcat(sbufferUDP0,rssiBf0);

        strcat(sbufferUDP0,"/");
        strcat(sbufferUDP0,rssiBf1);

        strcat(sbufferUDP0,"/");
        strcat(sbufferUDP0,rssiBf2);        
        
//        strcat(sbufferUDP0,"\r\n");        
        
        //送信先はマスターIP固定
        int scountUDP = udpsocket.sendto(DEF_UNITY_IP, UDP_Port_MASTER_RCV,sbufferUDP0, strlen(sbufferUDP0)+1);

        //null 部分まで送信するので＋１バイトと strlen でnull 直線までのバイト数を指定している
        
        //送信OKになっていても実際には外部への送信は完了していない
        //一定時間経過するまではソケットのクローズは行わないこと（早すぎると送信が完了しない）

        printf("\r\n");        
        printf("------------------------\r\n");        
        printf("Sent UDP Byte %d [%.*s]\r\n", scountUDP, strstr(sbufferUDP0, "\r\n")-sbufferUDP0, sbufferUDP0);
        printf("To IP %s Port %d_\r\n",DEF_UNITY_IP,UDP_Port_MASTER_RCV);
//        printf("%s\r\n",sbufferUDP0);
        printf("\r\n");        
        printf("------------------------\r\n");        
        
    } 
}

//---------------------------------------------------------------
//Cameraコマンド受信時応答コマンド
//---------------------------------------------------------------
void UDPctr::SLVsendUDPcomCamSet(int comId) {//int comId   //camEnable

    bool    checkFg = true;    

    //SleveNo コンパイルで自動設定
    int DefRcvNo;    
    int slvNo; 

    DefRcvNo = (int)DEF_RECEIVER_ID_SELECT;
    switch(DefRcvNo){
        case 1:
            slvNo=RCV_BEACON01; //レシーバ01
            break;
        case 2:
            slvNo=RCV_BEACON02; //レシーバ02
            break;        
        case 3:
            slvNo=RCV_BEACON03; //レシーバ03
            break;        
        default :            
            slvNo=0xff;
            break;
        
    }
    
    //-------------------------------------
    // 送信データの作成（送信先はマスターレシーバ）
    //-------------------------------------
    if(checkFg==true){
        
        char sbufferUDP0[50];                     //送信バッファ
        
        switch(comId){
            case comKeyCamOn://camera on
                char sbufferUDP1[] = "SetCameraON/";       //送信文字列  /BeconRecever/   キーワード
                strcpy(sbufferUDP0,sbufferUDP1);             //           
                break;
                
            case comKeyCamOff://camera off
                char sbufferUDP2[] = "SetCameraOFF/";       //送信文字列  /BeconRecever/   キーワード
                strcpy(sbufferUDP0,sbufferUDP2);             //           
                break;
                
            case comKeyRcvOn://rcv on          "SetCameraOFF/"
                char sbufferUDP3[] = "SetRcvON/";       //送信文字列  /BeconRecever/   キーワード
                strcpy(sbufferUDP0,sbufferUDP3);             //           
                break;

            case comKeyRcvOff://rcv on          "SetCameraOFF/"
                char sbufferUDP4[] = "SetRcvOFF/";       //送信文字列  /BeconRecever/   キーワード
                strcpy(sbufferUDP0,sbufferUDP4);             //           
                break;

                
            default:
                break;   
        }
        
        
        char sbuffer2[7];                            //          BeaconレシーバID
        get_ReceiverID(slvNo,sbuffer2);
               
        strcat(sbufferUDP0,sbuffer2);                // /SetCameraON/00000x/    ってなるはず・・・ "000001"        
                                                     // /SetCameraOFF
        strcat(sbufferUDP0,"/");
        
        //送信先はマスターIP固定
        int scountUDP = udpsocketCam.sendto(DEF_UNITY_IP, UDP_Port_ASTER__RCVCAM,sbufferUDP0, strlen(sbufferUDP0)+1);

        //null 部分まで送信するので＋１バイトと strlen でnull 直線までのバイト数を指定している
        
        printf("\r\n");        
        printf("------------------------\r\n");        
        printf("Sent UDP Byte %d [%.*s]\r\n", scountUDP, strstr(sbufferUDP0, "\r\n")-sbufferUDP0, sbufferUDP0);
        printf("To IP %s Port %d_\r\n",DEF_UNITY_IP,UDP_Port_MASTER_RCV);
        printf("\r\n");        
        printf("------------------------\r\n");        
        
    } 
}




//１メッセージ受信処理（いったん引数なし）（スレーブレシーバあて）
//今のところは処置なし（遠隔操作時など拡張時）
int UDPctr::SLVrcvUDPcom() {
    
    int rslt=-1;  //1 = Camera On, 0 = Camera Off ,-1 失敗
    //コマンドの受け渡しの引数を考える必要あり文字列配列だろうなぁ～    
    //UDPソケットOpen前提

    SocketAddress  UdpAdr;
    
    printf("UDP RCV Wait \r\n");
    char rbufferUDP[100];
    int rstudp=udpsocketCam.recvfrom(&UdpAdr,rbufferUDP,sizeof rbufferUDP);//あってる？
        
    printf("recv %d [%.*s]\r\n", rstudp, strstr(rbufferUDP, "\r\n")-rbufferUDP, rbufferUDP);
    printf("adr:    [%s][%d]\r\n", UdpAdr.get_ip_address(),UdpAdr.get_port());
    
    //keycode_dameraOn
    //keycode_dameraOff
    

//        char * keyCamOn  =  "CAMERA__ON";
//        char * keyCamOff =  "CAMERA_OFF";   

    
    if(rstudp >0){
//        if(strncmp(keyCamOn,rbufferUDP,rstudp ==0)){
//        }else if(strncmp(keyCamOff,rbufferUDP,rstudp)== 0){

        if(rbufferUDP[2]==0x01){
            printf("CAMERA ON GET\r\n");        
            SLVsendUDPcomCamSet(comKeyCamOn);  
            rslt=1;
                      
        }else if(rbufferUDP[2]==0x02){
            printf("CAMERA OFF GET\r\n");            
            SLVsendUDPcomCamSet(comKeyCamOff);
            rslt=0;
            
        }else{
            printf("MESSAGE ERR GET\r\n");                        
        }
        
        printf("camera message = %d \r\n", rstudp);
        printf("camera diff1 = %d \r\n", rbufferUDP[2]);
        printf("camera diff3 = %d \r\n", rbufferUDP);

    }
    
    return  rslt;

}
