#ifndef UDP_CTR_H
#define UDP_CTR_H
 
#include "EthernetInterface.h"
#include "UDPSocket.h"

#define comKeyCamOn    0
#define comKeyCamOff   1
#define comKeyRcvOn    2
#define comKeyRcvOff   3

class UDPctr {

//公開
public:

    
//          char sbufferUDP1[] = "BeconRecever/";       //送信文字列  /BeconRecever/   キーワード

    
    //変数
    EthernetInterface net;      //Ethernet設定

    UDPSocket udpsocket;           //UDPソケット
    UDPSocket udpsocketCam;        //UDPソケット
    
    
    //メソッド
    UDPctr();   //コンストラクタ？
    
    void EtherOpen();  //IPオープン
    void EtherClose(); //IPクローズ

    void UDPSocketOpen();
    void UDPSocketClose();


    
    
    //送信用関数
    void MainCtr();     //制御用
    
    
    //マスターレシーバ用(マスターレシーバシステムは封印)
    void MSTsendUDPcom(int sendSlvNo);     //1メッセージ送信関数 マスターに向けての送信処理（いったん共存させる）  
                                           //送信相手のスレーブビーコンIDを指定する                                    
    void MSTrcvUDPcom();                   //1メッセージｊ受信関数 receive の受信処理    （いったん共存させる）
    
    //---------------------------
    //スレーブレシーバ用
    //---------------------------
    void SLVsendUDPcomData(char * sendBffer,long sendSize);            //UDP大容量データ送信用
    void SLVsendUDPcom(char * rssiBf0,char * rssiBf1,char * rssiBf2); //3ビーコンコマンド送信専用（暫定）    
    int SLVrcvUDPcom();               //1メッセージ受信関数      
    
    void SLVsendUDPcomCamSet(int comId);   //camer On/Off 応答
    
    
//非公開
private:  
    
};
 
#endif